Module modSource

    Public objActiveShape(4) As PictureBox ' variable for the current moving shape
    Public objActiveVorm As Vorm
    Public intLevel As Integer = 1
    Public frmGame As New frmTrs
    Public lngScore As Long
    Public BlokTotaal As Integer = 0

    Public Sub Main()
        frmGame.ShowDialog()
    End Sub

    Public Structure Vorm
        ' structure for a shape with color (kleur) and position of each of the 4 blocks
        Public intID As Integer
        Public kleur As Integer
        Private prpX1 As Integer
        Private prpX2 As Integer
        Private prpX3 As Integer
        Private prpX4 As Integer
        Public Property posX1() As Integer
            Get
                Return prpX1
            End Get
            Set(ByVal Value As Integer)
                prpX1 = Value
            End Set
        End Property
        Public Property posX2() As Integer
            Get
                Return prpX2
            End Get
            Set(ByVal Value As Integer)
                prpX2 = Value
            End Set
        End Property
        Public Property posX3() As Integer
            Get
                Return prpX3
            End Get
            Set(ByVal Value As Integer)
                prpX3 = Value
            End Set
        End Property
        Public Property posX4() As Integer
            Get
                Return prpX4
            End Get
            Set(ByVal Value As Integer)
                prpX4 = Value
            End Set
        End Property
    End Structure

    Public Sub fetchNextShape()
        Dim rand As Integer
        Dim i As Integer

        Try ' place a random new shape on the form
            Randomize() ' new random seed
            ' each shape is coordinated in the following table:
            '
            ' 11|12|13|13
            ' 21|22|23|24
            ' 31|32|33|34
            ' 41|42|43|44
            '
            ' these coordinates are also used for the rotation of the shape
            BlokTotaal += 1
            rand = (Rnd() * 6) + 1
            objActiveVorm = New Vorm
            objActiveVorm.intID = rand
            With objActiveVorm
                Select Case rand
                    Case 1
                        .posX1 = 21
                        .posX2 = 22
                        .posX3 = 23
                        .posX4 = 33
                        .kleur = 0
                    Case 2
                        .posX1 = 31
                        .posX2 = 32
                        .posX3 = 33
                        .posX4 = 23
                        .kleur = 1
                    Case 3
                        .posX1 = 22
                        .posX2 = 32
                        .posX3 = 23
                        .posX4 = 33
                        .kleur = 2
                    Case 4
                        .posX1 = 31
                        .posX2 = 32
                        .posX3 = 22
                        .posX4 = 23
                        .kleur = 3
                    Case 5
                        .posX1 = 21
                        .posX2 = 22
                        .posX3 = 32
                        .posX4 = 33
                        .kleur = 4
                    Case 6
                        .posX1 = 21
                        .posX2 = 22
                        .posX3 = 23
                        .posX4 = 32
                        .kleur = 5
                    Case 7
                        .posX1 = 21
                        .posX2 = 22
                        .posX3 = 23
                        .posX4 = 24
                        .kleur = 6
                End Select
                objActiveShape.Clear(objActiveShape, 0, 4)
                For i = 0 To 3
                    ' set the active shape to the newly created blocks
                    objActiveShape(i) = New PictureBox
                Next i
                ' initial position and order of the blocks in the shape
                ' 1
                objActiveShape(0).Left = (5 * 20) + ((Mid(.posX1, 1, 1) - 1) * 20)
                objActiveShape(0).Top = -20 + (Mid(.posX1, 2, 1) * 20) + IIf(rand = 3, -20, 0)
                ' 2
                objActiveShape(1).Left = (5 * 20) + ((Mid(.posX2, 1, 1) - 1) * 20)
                objActiveShape(1).Top = -20 + (Mid(.posX2, 2, 1) * 20) + IIf(rand = 3, -20, 0)
                ' 3
                objActiveShape(2).Left = (5 * 20) + ((Mid(.posX3, 1, 1) - 1) * 20)
                objActiveShape(2).Top = -20 + (Mid(.posX3, 2, 1) * 20) + IIf(rand = 3, -20, 0)
                ' 4
                objActiveShape(3).Left = (5 * 20) + ((Mid(.posX4, 1, 1) - 1) * 20)
                objActiveShape(3).Top = -20 + (Mid(.posX4, 2, 1) * 20) + IIf(rand = 3, -20, 0)
                For i = 0 To 3
                    ' set object properties, image etc.
                    objActiveShape(i).Visible = False
                    objActiveShape(i).Image = frmGame.ilColor.Images.Item(.kleur)
                    objActiveShape(i).Height = 20
                    objActiveShape(i).Width = 20
                    objActiveShape(i).BorderStyle = BorderStyle.FixedSingle
                    frmGame.Controls.Add(objActiveShape(i))
                    objActiveShape(i).Parent = frmGame.picField
                    objActiveShape(i).BringToFront()
                    objActiveShape(i).Visible = True
                Next
                ' every 20 shapes a new level
                If BlokTotaal = 20 Then
                    BlokTotaal = 0
                    intLevel += 1
                    frmGame.lblLargeLevel.Text = intLevel
                    frmGame.lblLevel.Text = intLevel
                    ' increase the drop speed of the active shape with 1/8
                    frmGame.timFall.Interval -= frmGame.timFall.Interval / 8
                End If
                frmGame.timFall.Enabled = True
            End With
        Catch fout As Exception
            MessageBox.Show(fout.Message, "Fout opgetreden", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
        End Try
    End Sub

    Public Function checkCollision() As Boolean
        Dim i As Integer
        Dim ctl As Control

        Try
            ' check for collision with form borders, previously places shapes etc.
            frmGame.timFall.Enabled = False
            checkCollision = False ' default false
            For i = 0 To 3
                If objActiveShape(i).Top >= 380 Then
                    ' shape touches bottom
                    checkCollision = True
                    Exit For
                Else
                    ' frozen blocks get tag 'X'
                    For Each ctl In frmGame.picField.Controls
                        If ctl.Top = objActiveShape(i).Top + 20 And ctl.Tag = "X" And ctl.Left = objActiveShape(i).Left Then
                            checkCollision = True
                            Exit For
                        End If
                    Next
                End If
            Next
            If checkCollision = True Then
                For i = 0 To 3
                    objActiveShape(i).Tag = "X"
                    If objActiveShape(i).Top = 0 Then
                        ' shape touches ceiling; game is over
                        frmGame.timFall.Enabled = False
                        frmGame.timScore.Enabled = False
                        MessageBox.Show("GAME OVER" & Chr(13) & Chr(13) & "Je hebt " & lngScore & " punten behaald!", "", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        frmGame.Close()
                        frmGame = Nothing
                        End
                        Exit Function
                    End If
                Next
                checkFullRow()
            End If
            frmGame.timFall.Enabled = True
            Return checkCollision
        Catch fout As Exception
            MessageBox.Show(fout.Message, "Fout opgetreden", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
        End Try
    End Function

    Public Sub rotateShape()
        Dim i As Integer
        Dim ctl As Control

        Try
            ' shape rotates according to the positioning table (see comment in sub FetchNextShape)
            For i = 0 To 3
                Select Case CallByName(objActiveVorm, "posX" & i + 1, CallType.Get)
                    Case 44
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 41
                            Case 1
                                objActiveVorm.posX2 = 41
                            Case 2
                                objActiveVorm.posX3 = 41
                            Case 3
                                objActiveVorm.posX4 = 41
                        End Select
                        objActiveShape(i).Left += 0
                        objActiveShape(i).Top += -60
                    Case 34
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 42
                            Case 1
                                objActiveVorm.posX2 = 42
                            Case 2
                                objActiveVorm.posX3 = 42
                            Case 3
                                objActiveVorm.posX4 = 42
                        End Select
                        objActiveShape(i).Left += 20
                        objActiveShape(i).Top += -40
                    Case 24
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 43
                            Case 1
                                objActiveVorm.posX2 = 43
                            Case 2
                                objActiveVorm.posX3 = 43
                            Case 3
                                objActiveVorm.posX4 = 43
                        End Select
                        objActiveShape(i).Left += 40
                        objActiveShape(i).Top += -20
                    Case 14
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 44
                            Case 1
                                objActiveVorm.posX2 = 44
                            Case 2
                                objActiveVorm.posX3 = 44
                            Case 3
                                objActiveVorm.posX4 = 44
                        End Select
                        objActiveShape(i).Left += 60
                        objActiveShape(i).Top += 0
                    Case 43
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 31
                            Case 1
                                objActiveVorm.posX2 = 31
                            Case 2
                                objActiveVorm.posX3 = 31
                            Case 3
                                objActiveVorm.posX4 = 31
                        End Select
                        objActiveShape(i).Left += -20
                        objActiveShape(i).Top += -40
                    Case 33
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 32
                            Case 1
                                objActiveVorm.posX2 = 32
                            Case 2
                                objActiveVorm.posX3 = 32
                            Case 3
                                objActiveVorm.posX4 = 32
                        End Select
                        objActiveShape(i).Left += 0
                        objActiveShape(i).Top += -20
                    Case 23
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 33
                            Case 1
                                objActiveVorm.posX2 = 33
                            Case 2
                                objActiveVorm.posX3 = 33
                            Case 3
                                objActiveVorm.posX4 = 33
                        End Select
                        objActiveShape(i).Left += 20
                        objActiveShape(i).Top += 0
                    Case 13
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 34
                            Case 1
                                objActiveVorm.posX2 = 34
                            Case 2
                                objActiveVorm.posX3 = 34
                            Case 3
                                objActiveVorm.posX4 = 34
                        End Select
                        objActiveShape(i).Left += 40
                        objActiveShape(i).Top += 20
                    Case 42
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 21
                            Case 1
                                objActiveVorm.posX2 = 21
                            Case 2
                                objActiveVorm.posX3 = 21
                            Case 3
                                objActiveVorm.posX4 = 21
                        End Select
                        objActiveShape(i).Left += -40
                        objActiveShape(i).Top += -20
                    Case 32
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 22
                            Case 1
                                objActiveVorm.posX2 = 22
                            Case 2
                                objActiveVorm.posX3 = 22
                            Case 3
                                objActiveVorm.posX4 = 22
                        End Select
                        objActiveShape(i).Left += -20
                        objActiveShape(i).Top += 0
                    Case 22
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 23
                            Case 1
                                objActiveVorm.posX2 = 23
                            Case 2
                                objActiveVorm.posX3 = 23
                            Case 3
                                objActiveVorm.posX4 = 23
                        End Select
                        objActiveShape(i).Left += 0
                        objActiveShape(i).Top += 20
                    Case 12
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 24
                            Case 1
                                objActiveVorm.posX2 = 24
                            Case 2
                                objActiveVorm.posX3 = 24
                            Case 3
                                objActiveVorm.posX4 = 24
                        End Select
                        objActiveShape(i).Left += 20
                        objActiveShape(i).Top += 40
                    Case 41
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 11
                            Case 1
                                objActiveVorm.posX2 = 11
                            Case 2
                                objActiveVorm.posX3 = 11
                            Case 3
                                objActiveVorm.posX4 = 11
                        End Select
                        objActiveShape(i).Left += -60
                        objActiveShape(i).Top += 0
                    Case 31
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 12
                            Case 1
                                objActiveVorm.posX2 = 12
                            Case 2
                                objActiveVorm.posX3 = 12
                            Case 3
                                objActiveVorm.posX4 = 12
                        End Select
                        objActiveShape(i).Left += -40
                        objActiveShape(i).Top += +20
                    Case 21
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 13
                            Case 1
                                objActiveVorm.posX2 = 13
                            Case 2
                                objActiveVorm.posX3 = 13
                            Case 3
                                objActiveVorm.posX4 = 13
                        End Select
                        objActiveShape(i).Left += -20
                        objActiveShape(i).Top += 40
                    Case 11
                        Select Case i
                            Case 0
                                objActiveVorm.posX1 = 14
                            Case 1
                                objActiveVorm.posX2 = 14
                            Case 2
                                objActiveVorm.posX3 = 14
                            Case 3
                                objActiveVorm.posX4 = 14
                        End Select
                        objActiveShape(i).Left += 0
                        objActiveShape(i).Top += -60
                End Select
                ' Make sure the rotating doesn't put the shape outside the form borders
                If objActiveShape(i).Left < 0 Then
                    objActiveShape(0).Left += 20
                    objActiveShape(1).Left += 20
                    objActiveShape(2).Left += 20
                    objActiveShape(3).Left += 20
                ElseIf objActiveShape(i).Left > 290 Then
                    objActiveShape(0).Left -= 20
                    objActiveShape(1).Left -= 20
                    objActiveShape(2).Left -= 20
                    objActiveShape(3).Left -= 20
                End If
            Next
        Catch fout As Exception
            MessageBox.Show(fout.Message, "Fout opgetreden", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
        End Try
    End Sub

    Private Sub checkFullRow()
        Dim i As Integer
        Dim blokCount As Integer
        Dim rowCount As Integer
        Dim ctl As Control

        Try 'Check for a full horizontal row (with stationary blocks)
            For i = 0 To 19
                For Each ctl In frmGame.picField.Controls
                    If ctl.Tag = "X" And ctl.Top = i * 20 Then
                        blokCount = blokCount + 1
                    End If
                Next
                If blokCount = 15 Then
                    rowCount = rowCount + 1
                    frmGame.lblFlash.Top = i * 20
                    For Each ctl In frmGame.picField.Controls
                        If ctl.Tag = "X" And ctl.Top = i * 20 Then
                            ctl.Tag = "G"
                            ctl.Visible = False
                        ElseIf ctl.Tag = "X" And ctl.Top < i * 20 Then
                            ctl.Top = ctl.Top + 20
                        End If
                    Next
                End If
                blokCount = 0
            Next i
            If rowCount > 0 Then
                i = 0
                ' remove the blocks in the full row, and descend the blocks above 1 square
                Do While i < frmGame.picField.Controls.Count - 1
                    If frmGame.picField.Controls(i).Visible = False And frmGame.picField.Controls(i).Name <> "lblFlash" Then
                        frmGame.picField.Controls.RemoveAt(i)
                    Else
                        i = i + 1
                    End If
                Loop
                frmGame.lblFlash.BringToFront()
                frmGame.lblFlash.Height = rowCount * 20
                frmGame.lblFlash.Top -= 20 * (rowCount - 1)
                frmGame.lblFlash.Visible = True
                lngScore += (100 * (rowCount * rowCount))
                frmGame.lblScore.Text = lngScore
                frmGame.timScore.Enabled = True
                frmGame.timFall.Enabled = False
            End If
        Catch fout As Exception
            MessageBox.Show(fout.Message, "Fout opgetreden", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
        End Try
    End Sub
End Module
